package yrpg.application.crmvisit.plugin.form;

import kd.bos.bill.MobileBillShowParameter;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractMobFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;

/**
 * 动态表单插件(移动端)
 * 新增专家-弹框
 */
public class ExpertPopupMobFormPlugin extends AbstractMobFormPlugin implements Plugin {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("yrpg_btnok");
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control)evt.getSource();
        String key = source.getKey();
        if (key.equals("yrpg_btnok")){
            String expertNum = String.valueOf(this.getModel().getValue("yrpg_expertnum")).trim();
            if(expertNum.isEmpty()){
                this.getView().showTipNotification("请填写执业证书编号");
            }else{
                QFilter filter = new QFilter("yrpg_expert_number", QCP.equals, expertNum);
                filter.and("status",QCP.equals,"C");
                filter.and("enable",QCP.equals,"1");
                DynamicObject expertBase = QueryServiceHelper.queryOne("yrpg_yzj_expert_base", "id,name", filter.toArray());
                if (expertBase!=null){
                    //申请维护人界面,带专家信息
                    showMobileForm("yrpg_relationship_bind_mob",null,"申请维护人",expertBase);
                }else {
                    //新增专家界面,携带证书编号
                    showMobileForm("yrpg_yzj_expert_base_mob",expertNum,"专家的基础资料库",expertBase);
                }

            }
        }
    }

    private void showMobileForm(String formId,String expertNum,String caption,DynamicObject expertBase){
        MobileBillShowParameter showParameter = new MobileBillShowParameter();
        showParameter.setFormId(formId);
        if (expertNum!=null){
            showParameter.setCustomParam("expertNum",expertNum);
        }
        if (expertBase!=null){
            QFilter filter = new QFilter("yrpg_expert_name.id", QCP.equals, expertBase.getLong("id"));
            DynamicObject expert = BusinessDataServiceHelper.loadSingle("yrpg_crm_expert","id",filter.toArray());
            if (expert!=null){
                showParameter.setCustomParam("expertBase",expert.getLong("id"));
            }

        }
        showParameter.setCaption(caption);
        showParameter.getOpenStyle().setShowType(ShowType.Floating);
        this.getView().showForm(showParameter);
        this.getView().invokeOperation("close");
    }
}